#include "libspc.h"
#include "spcwin.h"
#include <string.h>
#include <Be.h>
#include "InputPlugin.h"
#include "def.h"

char *spc_id666_filename;
bool playing = false;
extern char songnam[33];
extern char gametit[33];
extern char dumpe[17];
extern char comment[33];
extern char auth[33];
extern int playtim;
extern int fadetim;
extern int i;
uint8 *buf;
int size;

SPC_Config spc_config = {
    44100,
    16,
    2,
    1,
    1
};
SPC_ID666 *spc_id666;


extern "C" _EXPORT InputPlugin *NewPlugin(int *version);

InputPlugin *NewPlugin(int *version)
{
	*version = CURRENT_INPUT_PLUGIN_VERSION;
	return new SpcPlugin();
}

SpcPlugin::SpcPlugin() : InputPlugin("SPC", "SpcPlayer player by Carwyn Jones")
{
	
}

void SpcPlugin::Cleanup()
{

}


void SpcPlugin::Init()
{

}

bool SpcPlugin::About(bool Question)
{
	if (!Question) {
		BAlert *alert = new BAlert("",
		"SpcPlayer\nVersion 1.0\n\nMade by Carwyn Jones\nE-mail: turok2@currantbun.com\nhttp://www.infernal.currantbun.com\n\nBased on the xmms plugin and\nlibspc made by AGAWA Koji\n\n",
		"Ok", NULL, NULL, B_WIDTH_FROM_LABEL);
		
		BTextView *theText = alert->TextView();
		if(theText) {
			theText->SetStylable(true);
			theText->Select(0,9);

			BFont ourFont;

			theText->SetFontAndColor(be_bold_font);
			theText->GetFontAndColor(2, &ourFont, NULL);
			ourFont.SetSize(24);
			theText->SetFontAndColor(&ourFont);
		}
		alert->Go();
	}
	return true;
}


bool SpcPlugin::Prefs(bool Question)
{
	if (!Question) {
	
	}
		return false;

	
}


bool SpcPlugin::Edit(const char *FileName, bool Question)
{
	if(!Question) {
	BRect r(322, 194, 518, 399);
	spcwin = new SpcWin(r);
	spcwin->Show();
	spc_id666 = SPC_get_id666(FileName);
	
	spcwin->Lock();
	if(spc_id666) {
	spcwin->song->SetText(spc_id666->songname);
	spcwin->game->SetText(spc_id666->gametitle);
	spcwin->dump->SetText(spc_id666->dumper);
	spcwin->author->SetText(spc_id666->author);
	spcwin->comments->SetText(spc_id666->comments);
	}
	spcwin->Unlock();
	spc_id666_filename = strdup(FileName);
	printf("%s\n", spc_id666_filename);
	
	}
	return true;
}

void SpcPlugin::tag_set_states()
{
spcwin->tag_set_states();

}


void SpcPlugin::MessageReceived(BMessage *message)
{
switch(message->what) {

	case SAV:
	
		if (spc_id666) {
		
		spc_id666->songname = songnam;
		spc_id666->gametitle = gametit;
		spc_id666->dumper = dumpe;
		spc_id666->comments = comment;
		spc_id666->author = auth;
		

		SPC_write_id666 (spc_id666, spc_id666_filename);

      	free (spc_id666);
      	spc_id666 = NULL;
      //free (spc_id666_filename);
      	spc_id666_filename = NULL;
		}   
      break;
	}
}


bool SpcPlugin::GetMimeType(BMimeType *m, int nr)
{
	if (nr == 0) {
		m->SetTo("audio/x-spc");
		m->SetLongDescription("Snes Spc Song");
		return true;
	} else
		return false;
}


bool SpcPlugin::IsOur(const char *FileName)
{
	char *ext;
	ext = strrchr(FileName, '.');
	if(ext)
	if((!strcasecmp(ext, ".spc")) || (!strcasecmp(ext, ".sp1")) || (!strcasecmp(ext, ".sp2"))
	|| (!strcasecmp(ext, ".sp3")) || (!strcasecmp(ext, ".sp4")) || (!strcasecmp(ext, ".sp5"))
	|| (!strcasecmp(ext, ".sp6")) || (!strcasecmp(ext, ".sp7")) || (!strcasecmp(ext, ".sp8"))
	|| (!strcasecmp(ext, ".sp9")) || (!strcasecmp(ext, ".SPC")) || (!strcasecmp(ext, ".SP1"))
	|| (!strcasecmp(ext, ".SP2")) || (!strcasecmp(ext, ".SP3")) || (!strcasecmp(ext, ".SP4"))
	|| (!strcasecmp(ext, ".SP5")) || (!strcasecmp(ext, ".SP6")) || (!strcasecmp(ext, ".SP7"))
	|| (!strcasecmp(ext, ".SP8")) || (!strcasecmp(ext, ".SP9")))
	return 1;
	
return 0;
}

bool SpcPlugin::GetSongInfo(const char *FileName, PlayerInfoStruct *Info)
{
char name[100];
char *nonsense = " ";
spc_id666 = SPC_get_id666(FileName);

if(spc_id666) {
sprintf(name, "%s %s", spc_id666->gametitle,spc_id666->songname);
}

	if(!spc_id666)
	{
	strcpy(name, nonsense);
	}

	if(!strcmp(name, " "))
	{
	Info->Title = Info->Title; 
	}
	
	else {
	Info->Title = name;
	}

	return true;
}

void SpcPlugin::AbortPlaying()
{
}




void SpcPlugin::Pause(bool On)
{
}


void SpcPlugin::NewSpeed(long Promille)
{

}


void SpcPlugin::NewVolume(long Promille)
{
}


bool SpcPlugin::InitPlaying(const char *FileName, PlayerInfoStruct *Info)
{
	
	if(!SPC_load(FileName))
	return false;
    


	size = SPC_init(&spc_config);
	buf = (uint8 *)malloc(size);
  
    Info->Flags = INPLUG_NO_TOTTIME | INPLUG_NO_CURRTIME | INPLUG_HANDLE_SPEED;
	Info->Frequency = 44100;
	Info->Stereo = true;
	return true;
}


int SpcPlugin::GetAudio(char **Buff, int Size)
{

SPC_update(buf);

*Buff = (char *)buf;

return size;

}

void SpcPlugin::JumpTo(long NewTime)
{
}


void SpcPlugin::CleanupPlaying()
{
}


